/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#ifndef ANIMMATION_H
#define ANIMMATION_H
#include <QtCore>
#include <QAction>
#include <QTimer>
#include <QObject>
#include <QWidget>
class Animmation: public QObject
{
    Q_OBJECT
public:
    explicit Animmation(QObject *parent = 0);

public slots:
    void AnimationStart(QAction *btn, QSize size);
void AnimationStop();
void setStyle(int style)
{
    m_style=style;
}

private:
    QTimer *timerAnim;
int m_style;
    QAction *buttonAct;
    int m_iconSize;

    int m_animStyle;

    QPixmap m_pix;
    qreal m_rot;
    qreal m_def;
private slots:

   void goAnimation();

   void buttonZoomIn();
    void buttonRotate();
    void buttonImage();
};

#endif // ANIMMATION_H
