/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#include "dialogsettings.h"
#include "ui_dialogsettings.h"
#include "about/widgetabout.h"
#include <QSettings>
#include <QColorDialog>
#include <QFileDialog>
#include <QDebug>
#include <QTextCodec>
#include <QPainter>
#define STYLE_GRAD  0
#define STYLE_IMAGE  1
#define STYLE_3D 2
DialogSettings::DialogSettings(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DialogSettings)
{
    ui->setupUi(this);
      iconsSetting=new widgetIconsThemes;
      ui->verticalLayoutIcons->addWidget(iconsSetting);
    QString locale = QLocale::system().name().section("_",0,0);

    if(locale=="ar")
        setLayoutDirection(Qt::RightToLeft);
    this->setWindowIcon(QIcon::fromTheme("configure",QIcon::fromTheme("document-properties")));
    this->setObjectName("dockConfig");
    this->setAttribute(Qt::WA_DeleteOnClose,true);
    /* اضافة صور الشكل الثلاثي الى القائمة المنسدلة*/
    ui->comboBox3D->addItem(QIcon(":/images/bgrGlass.svg"), tr("White"),":/images/bgrGlass.svg");
    ui->comboBox3D->addItem(QIcon(":/images/bgrGlassR.svg"), tr("White Rounded"),":/images/bgrGlassR.svg");
    ui-> comboBox3D->addItem(QIcon(":/images/bgrBlack.svg"), tr("Black"),":/images/bgrBlack.svg");
    ui->comboBox3D->addItem(QIcon(":/images/bgrBlackR.svg"), tr("Black Rounded"),":/images/bgrBlackR.svg");

    WidgetAbout *wAbout=new WidgetAbout;
    wAbout->setPixmap(QIcon::fromTheme("elokab-dock",QIcon(":/icons/elokab-dock.png")).pixmap(96));
    ui->verticalLayoutAbout->addWidget(wAbout);
    loadSetting();

    /*تطبيق الشكل هلى المعاينة*/
    getStyleGradien();
    //***********************






   // on_comboBoxIcons_activated(indx);
}

DialogSettings::~DialogSettings()
{
    delete ui;
}
QString DialogSettings::getDirIconTeme(QString dir)
{
          QDir dirPath(dir);
          if(!QFile::exists(dir+"/index.theme"))return "";


          QSettings settings(dir+"/index.theme",QSettings::IniFormat);
          //settings.setIniCodec(QTextCodec::codecForName("UTF-8"));
          settings.beginGroup("Icon Theme");
          if(!settings.contains("Directories"))return "" ;
          QString name=settings.value("Name","").toString();
          //   QString directories=settings.value("Example","").toString();
          // qDebug()<<dir+"/index.theme  :"<<name<<" : "<<directories;
          settings.endGroup();
return dirPath.dirName();
          //   if (directories.isEmpty())return ;
       //   ui->comboBoxIcons->addItem(dirPath.dirName(),name);
          //qDebug()<<dirPath.dirName();
}
void DialogSettings::loadSetting()
{
    QSettings setting("elokab","settings");
    /*تحميل كل اعدادات الممستخدم من الوان واشكال وموضع الى الخ
     كل هذه المعلومات موجودة افتراضيا في مجلد المستخدم في هذا المسار
     QDir::homePath()+"/.config/elokab/applictions*/
    setting.beginGroup("Dock-Style");
    ui->comboBoxPosition->setCurrentIndex(setting.value("position",0).toInt());
    ui->comboBoxScreenEdge->setCurrentIndex(setting.value("screenEdge",0).toInt());
    ui->spinBoxIconSize->setValue(setting.value("iconSize",48).toInt());
    ui->comboBoxAnim->setCurrentIndex(setting.value("animmationStyle",0).toInt());
  //ui->checkBoxiconsDefault->setChecked(setting.value("isDefaulticons",true).toBool());
//          QString iconstheme=setting.value("iconsTheme",QIcon::themeName()).toString();

 QColor   colorTop=setting.value("color1",QColor(56, 56, 56, 255)).value<QColor>();
 QColor   colorRight=setting.value("color2",QColor(76, 76, 76, 255)).value<QColor>();
 QColor   colorBot=setting.value("color3",QColor(0, 0, 0, 255)).value<QColor>();
 QColor   colorLeft=setting.value("color4",QColor(43, 43, 43, 255)).value<QColor>();
 QColor   colorBorder=setting.value("colorBorder",QColor(34, 34,34,255)).value<QColor>();
 QColor   colorSelect=setting.value("colorSelect",QColor(255, 50, 20,255)).value<QColor>();

    m_stop=setting.value("stop","0.02").toString();
    m_stop2=setting.value("stop2","0.96").toString();
    ui->lineEditImageFile->setText(setting.value("pixFileName","").toString());
  ui->checkBoxRepeat->setChecked(setting.value("imageRepeat",false).toBool());
    ui->spinBoxBleft->setValue(setting.value("borderLeft",5).toInt());
    ui->spinBoxBright->setValue(setting.value("borderRight",5).toInt());
    ui->spinBoxBtop->setValue(setting.value("borderTop",3).toInt());
    ui->spinBoxBbottom->setValue(setting.value("borderBot",1).toInt());
    ui->comboBoxBackStyle->setCurrentIndex(setting.value("backgroundStyle",STYLE_GRAD).toInt());
    ui->comboBox3D->setCurrentIndex(setting.value("image3D",0).toInt());
    ui->checkBoxSelectionColor->setChecked(setting.value("showSelection",true).toBool());


    setting.endGroup();

    btn_colorTop   =new ButtonColor(colorTop);
    btn_colorRight=new ButtonColor(colorRight);
    btn_colorBot=new ButtonColor(colorBot);
    btn_colorLeft=new ButtonColor(colorLeft);
    btn_colorBorder=new ButtonColor(colorBorder);
    btn_colorSelect=new ButtonColor(colorSelect);

      connect(btn_colorTop,SIGNAL(colorChanged()),this,SLOT(getStyleGradien()));
      connect(btn_colorRight,SIGNAL(colorChanged()),this,SLOT(getStyleGradien()));
       connect(btn_colorBot,SIGNAL(colorChanged()),this,SLOT(getStyleGradien()));
          connect(btn_colorLeft,SIGNAL(colorChanged()),this,SLOT(getStyleGradien()));
          connect(btn_colorBorder,SIGNAL(colorChanged()),this,SLOT(getStyleGradien()));
          connect(btn_colorSelect,SIGNAL(colorChanged()),this,SLOT(getStyleGradien()));

ui->horizontalLayout_top->addWidget(btn_colorTop);
ui->horizontalLayout_bot->addWidget(btn_colorBot);
ui->horizontalLayout_center->insertWidget(0,btn_colorLeft);
ui->horizontalLayout_center->addWidget(btn_colorRight);
ui->horizontalLayout_select->addWidget(btn_colorSelect);
ui->horizontalLayout_border->addWidget(btn_colorBorder);


    //applique gui---------------------------------------
    QString dd=m_stop;
    dd.remove("0.");
    ui->verticalSlider->setValue(dd.toInt());
    QString dd2=m_stop2;
    dd2.remove("0.");
    ui->verticalSlider2->setValue(dd2.toInt());
}
void DialogSettings::saveSetting()
{
    QSettings setting("elokab","settings");

    setting.beginGroup("Dock-Style");

    setting.setValue("position",ui->comboBoxPosition->currentIndex());

    setting.setValue("screenEdge",ui->comboBoxScreenEdge->currentIndex());

    setting.setValue("iconSize",ui->spinBoxIconSize->value());

    setting.setValue("animmationStyle",ui->comboBoxAnim->currentIndex());

//setting.setValue("isDefaulticons",ui->checkBoxiconsDefault->isChecked());



 // setting.setValue("styleSheet",getStyle());


    setting.setValue("color1",btn_colorTop->color());

    setting.setValue("color2",btn_colorRight->color());

    setting.setValue("color3",btn_colorBot->color());

    setting.setValue("color4",btn_colorLeft->color());

    setting.setValue("colorBorder",btn_colorBorder->color());

    setting.setValue("colorSelect",btn_colorSelect->color());

    setting.setValue("stop",m_stop);

    setting.setValue("stop2",m_stop2);

    setting.setValue("pixFileName", ui->lineEditImageFile->text());
    setting.setValue("imageRepeat", ui->checkBoxRepeat->isChecked());


    setting.setValue("borderLeft", ui->spinBoxBleft->value());

    setting.setValue("borderRight", ui->spinBoxBright->value());

    setting.setValue("borderTop", ui->spinBoxBtop->value());

    setting.setValue("borderBot", ui->spinBoxBbottom->value());

    setting.setValue("backgroundStyle", ui->comboBoxBackStyle->currentIndex());

    setting.setValue("image3D", ui->comboBox3D->currentIndex());

    setting.setValue("showSelection",ui->checkBoxSelectionColor->isChecked());

    setting.endGroup();
//    QSettings settingIcons("elokab","elokabsettings");

//    settingIcons.beginGroup("Themes");

//      settingIcons.setValue("iconsTheme",ui->comboBoxIcons->currentText());
//    settingIcons.endGroup();
    saveStyleQss();
iconsSetting->saveIconThemes();
}

void DialogSettings::on_buttonBox_clicked(QAbstractButton *button)
{
    if(ui->buttonBox->standardButton(button)==QDialogButtonBox::Apply){
        saveSetting();
        emit accepteChange();

    }else   if(ui->buttonBox->standardButton(button)==QDialogButtonBox::Ok){
        saveSetting();
        emit accepteChange();
        this->accept();
    }
}
//*****************************************


void DialogSettings::on_verticalSlider_sliderMoved(int position)
{
    qreal q=position;
    QVariant d=q/100;
    m_stop=d.toString();
    getStyleGradien();
}
void DialogSettings::on_verticalSlider2_sliderMoved(int position)
{
    qreal q=position;
    QVariant d=q/100;
    m_stop2=d.toString();
    getStyleGradien();
}
QString DialogSettings::getStyleGradien()
{

    QString grad1=QString("stop:0 rgba(%1, %2, %3, %4), ")
            .arg(btn_colorTop->color().red()).arg(btn_colorTop->color().green())
            .arg(btn_colorTop->color().blue()).arg(btn_colorTop->color().alpha());
    QString grad2=QString("stop:%1 rgba(%2, %3, %4, %5),")
            .arg(m_stop).arg(btn_colorRight->color().red()).arg(btn_colorRight->color().green())
            .arg(btn_colorRight->color().blue()).arg(btn_colorRight->color().alpha());
    QString grad4=QString("stop:%1 rgba(%2, %3, %4, %5),")
            .arg(m_stop2).arg(btn_colorLeft->color().red()).arg(btn_colorLeft->color().green())
            .arg(btn_colorLeft->color().blue()).arg(btn_colorLeft->color().alpha());
    QString grad3=QString( "stop:1 rgba(%1, %2, %3, %4));")
            .arg(btn_colorBot->color().red()).arg(btn_colorBot->color().green())
            .arg(btn_colorBot->color().blue()).arg(btn_colorBot->color().alpha());
    QString borderRadius;



    if(ui->comboBoxScreenEdge->currentIndex()==0){
        borderRadius=QString("border-top-left-radius :%1px;"
                "border-top-right-radius : %2px;") .arg(QString::number(ui->spinBoxBleft->value()))
                .arg(QString::number(ui->spinBoxBright->value()));
    }else {
        borderRadius=QString("border-bottom-left-radius :%1px;"
                "border-bottom-right-radius :%2px;") .arg(QString::number(ui->spinBoxBleft->value()))
                .arg(QString::number(ui->spinBoxBright->value()));
    }

    QString styleBorder= QString("\n  border:	1px solid rgba(%1, %2, %3,%4);"
                                 " %5")
            .arg(btn_colorBorder->color().red()).arg(btn_colorBorder->color().green())
            .arg(btn_colorBorder->color().blue()).arg(btn_colorBorder->color().alpha()).arg(borderRadius);

    QString myStyle= QString("QWidget #widgetBgr{background-color: qlineargradient(spread:pad,"
                             "x1:0, y1:0, x2:0, y2:1, %1 %2 %3 %4")
            .arg(grad1).arg(grad2).arg(grad4).arg(grad3);

    ui->widgetBgr->setStyleSheet(myStyle+styleBorder+"}");
    return myStyle+styleBorder+"}";
}

void DialogSettings::on_toolButtonImage_clicked()
{
    QString  fileName = QFileDialog::getOpenFileName(this,
             tr("Open Image"), QDir::homePath(), tr("Image Files (*.png *.jpg *.bmp *.svg)"));

    if(!fileName.isEmpty()){
        ui->lineEditImageFile->setText(fileName);

    }
}

void DialogSettings::saveStyleQss()
{


    QString myStyle,mystyleButton;

    if(ui->comboBoxBackStyle->currentIndex()==STYLE_GRAD){
        myStyle=getStyleGradien();
    }else if(ui->comboBoxBackStyle->currentIndex()==STYLE_IMAGE){
        myStyle=getStyleImage();
    }else if(ui->comboBoxBackStyle->currentIndex()==STYLE_3D){
        myStyle=getStyle3D();
    }


    mystyleButton=QString(  "QToolButton {"
                            " background-color:transparent;"
                            "  border: 1px solid  transparent;"
                            "  border-radius: 4px;"
                            " }"

                            "QToolButton#btnTask {"
                            "background-color: qconicalgradient(cx:0.5, cy:0.9, angle:90,"
                            "stop:0.324022 rgba(255, 0, 0, 0), stop:0.357542 rgba(0, 0, 0, 0),"
                            "stop:0.385475 rgba(%1, %2, %3, 255), stop:0.597765 rgba(%1, %2, %3, 255),"
                            "stop:0.625698 rgba(0, 0, 0, 0), stop:0.670391 rgba(255, 0, 0, 0));"
                            "  border-radius: 4px;"
                            " }"

                            "  DActionTaskbar#btnTask:checked {"
                            "  border: 1px solid  rgba(%1, %2, %3, %4);"
                            "  border-radius: 4px;}"
                            "  DActionTaskbar#btnTask:checked:hover {"
                            "  border: 1px solid  rgba(%1, %2, %3, %4);"
                            "  border-radius: 4px;}"
                            ).arg(btn_colorSelect->color().red()).arg(btn_colorSelect->color() .green()).arg(btn_colorSelect->color().blue())
            .arg(btn_colorSelect->color().alpha()) ;
    QString mystyleButtonHover;
    if(ui->checkBoxSelectionColor->isChecked()){
        mystyleButtonHover=QString("  QToolButton:hover {"
                                   "  background-color:  rgba(%1, %2, %3, %4);"
                                   "  border: 1px solid  rgba(%5, %6, %7, %8);"
                                   "  border-radius: 4px;"
                                   "      }"
                                   "  QToolButton#btnTask:hover {"
                                   "  background-color: rgba(%1, %2, %3, %4);"
                                   "  border: 1px solid  rgba(%5, %6, %7, %8);"
                                   "  border-radius: 4px;"
                                   "      }")
                .arg(btn_colorSelect->color().red()).arg(btn_colorSelect->color() .green()).arg(btn_colorSelect->color().blue())
                .arg(btn_colorSelect->color().alpha()) .arg(btn_colorBorder->color().red()).arg(btn_colorBorder->color() .green())
                .arg(btn_colorBorder->color().blue()).arg(btn_colorBorder->color().alpha());


    }else{
        mystyleButtonHover=QString("  QToolButton:hover {"
                                   "  background-color: transparent;"
                                   "  border: 1px solid  transparent;}"
                                   "  QToolButton#btnTask:hover {"
                                   "  background-color: transparent;"
                                   "  border: 1px solid  transparent;}");
    }
    QFile fileCsv(QDir::homePath()+"/.config/elokab/dockTheme.css");
    if (!fileCsv.open(QFile::WriteOnly)){
    //    return ;
        qDebug()<<QDir::homePath()+"/.config/dockTheme.css";
    }
    QTextStream out(&fileCsv);
     out.setCodec(QTextCodec::codecForLocale());
    out<<myStyle+mystyleButton+mystyleButtonHover;
 //   return myStyle+mystyleButton+mystyleButtonHover;
}

QString DialogSettings::getStyleImage()
{
        QString myStyle;
        QString borderRadius;
        if(ui->checkBoxRepeat->isChecked()){
                if(ui->comboBoxScreenEdge->currentIndex()==0){
                    borderRadius=QString("border-top-left-radius :%1px;"
                            "border-top-right-radius : %2px;") .arg(QString::number(ui->spinBoxBleft->value()))
                            .arg(QString::number(ui->spinBoxBright->value()));
                }else {
                    borderRadius=QString("border-bottom-left-radius :%1px;"
                            "border-bottom-right-radius :%2px;") .arg(QString::number(ui->spinBoxBleft->value()))
                            .arg(QString::number(ui->spinBoxBright->value()));
                }

                QString styleBorder= QString("\n  border:	1px solid rgba(%1, %2, %3,%4);"
                                             " %5")
                        .arg(btn_colorBorder->color().red()).arg(btn_colorBorder->color().green())
                        .arg(btn_colorBorder->color().blue()).arg(btn_colorBorder->color().alpha()).arg(borderRadius);


           myStyle=  QString("QWidget #widgetBgr{"
                               " background-image: url(%1) %2 %3 %4 %5;"
                                "background-repeat: repeat-xy;"
                               " border-top:%2 px transparent;"
                               " border-left: %3px transparent;"
                               " border-bottom:%4 px transparent;"
                               " border-right: %5px transparent;"


                               ).arg(ui->lineEditImageFile->text())
              .arg(QString::number(ui->spinBoxBtop->value()))
              .arg(QString::number(ui->spinBoxBleft->value()))
              .arg(QString::number(ui->spinBoxBbottom->value()))
              .arg(QString::number(ui->spinBoxBright->value()));

           myStyle=myStyle+styleBorder+ " }";
           qDebug()<<myStyle+styleBorder;
        }else{
           myStyle= QString("QWidget #widgetBgr{"
                              "border-image: url(%1) %2 %3 %4 %5;"
                              " border-top:%2 px transparent;"
                              " border-left: %3px transparent;"
                              " border-bottom:%4 px transparent;"
                              " border-right: %5px transparent;"
                              " }"

                              ).arg(ui->lineEditImageFile->text())
             .arg(QString::number(ui->spinBoxBtop->value()))
             .arg(QString::number(ui->spinBoxBleft->value()))
             .arg(QString::number(ui->spinBoxBbottom->value()))
             .arg(QString::number(ui->spinBoxBright->value()));
        }

    return myStyle;
}
QString DialogSettings::getStyle3D()
{
    ui->spinBoxBtop->setValue(0);
    ui->spinBoxBleft->setValue(30);
    ui->spinBoxBbottom->setValue(7);
    ui->spinBoxBright->setValue(30);
    QString imageName=ui->comboBox3D->itemData(ui->comboBox3D->currentIndex()).toString();
    QString style3d=QString("QWidget #widgetBgr{"
                            "border-image: url(%1) 0 30 0 30;"
                            " border-top:%2 px transparent;"
                            " border-bottom:0px transparent;"
                            " border-right: 30px transparent;"
                            "  border-left: 30px transparent;"
                            " }"

                            ).arg(imageName).arg(ui->spinBoxIconSize->value()/2+8);

    return style3d;
}

void DialogSettings::on_comboBoxScreenEdge_activated(const QString /*&arg1*/)
{
    getStyleGradien();
}

