/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#ifndef DIALOGSETTINGS_H
#define DIALOGSETTINGS_H
#include "icontheme/widgeticonsthemes.h"
#include "buttoncolor/buttoncolor.h"

#include <QDialog>
#include <QAbstractButton>

#define GRAD_TOP   1
#define GRAD_RIGHT   2
#define GRAD_BOT   3
#define GRAD_LEFT  4
#define COLOR_BORDER  5
#define COLOR_SELECT  6


namespace Ui {
    class DialogSettings;
}

class DialogSettings : public QDialog
{
    Q_OBJECT

public:
    explicit DialogSettings(QWidget *parent = 0);
    ~DialogSettings();
signals :
    void accepteChange();
private:
    Ui::DialogSettings *ui;

    QString m_stop,m_stop2;



 QString m_iconsTheme;

 widgetIconsThemes *iconsSetting;

 ButtonColor *btn_colorTop,*btn_colorRight,*btn_colorBot,*btn_colorLeft;
 ButtonColor  *btn_colorBorder,*btn_colorSelect;

private slots:
QString getDirIconTeme(QString dir);
    void loadSetting();

    void saveSetting();

    void on_buttonBox_clicked(QAbstractButton *button);


    void on_verticalSlider_sliderMoved(int position);

    void on_verticalSlider2_sliderMoved(int position);


    void on_toolButtonImage_clicked();

    QString getStyleGradien();

    void saveStyleQss();

    QString getStyleImage();

    QString getStyle3D();


    void on_comboBoxScreenEdge_activated(const QString);

};

#endif // DIALOGSETTINGS_H
