/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#ifndef DOCKBARWIDGET_H
#define DOCKBARWIDGET_H
#include "dquicklaunch/dactiontaskbar.h"
#include <X11/Xlib.h>
#include <X11/X.h>
#include "elokabsettings.h"
#include <QWidget>
#include <QToolButton>
#include <QMouseEvent>
class QuickLaunchAction;
class QDragEnterEvent;
class QuickLaunchLayout;
class QuickLaunchButton;


namespace Ui {
class DockBarWidget;
}

class DockBarWidget : public QWidget
{
    Q_OBJECT

public:
    explicit DockBarWidget(QWidget *parent = 0);
    ~DockBarWidget();
    void show();
    QAction *actAddActions;
    QAction *actSettings;
    QAction *actQuit;
    void  x11EventFilter(XEvent* event);
    //************
    int indexOfButton(QuickLaunchButton* button) const;
    int countOfButtons() const;
protected :

    void resizeEvent (QResizeEvent *);
    void enterEvent(QEvent *);
    void leaveEvent(QEvent *);
private:
    Ui::DockBarWidget *ui;
    int m_minH;
    //int m_maxH;
    bool  m_onTop;
    int m_positionType;
    int m_screenEdge;
  //  int m_style;
    int m_animmationStyle;
    bool m_autoHide;
    QTimer *timerShow;
    QTimer *timerHide;
    QTimer *timerShowHide;
    bool mouseEntered;
    QSize m_size;
    //***************************
    QuickLaunchLayout *m_layout;
    QHash<int,QuickLaunchButton*> m_buttonsQuick;
int m_wmBorder;


    //task
    QHash<Window, DActionTaskbar*> m_buttonsTask;
    QAction *m_actAddToLancher;
    Qt::ToolButtonStyle mButtonStyle;
    Window m_rootWindow;
elokabSettings *m_settings;
private slots:
void crateStyle();
    void resizeDock();

    void moveToHide();
    void moveToShow();


//    QString setStyleDefault();
    void loadSetting();
     void loadIconThemes();
    void reserveSpace(bool arg);
    void dockSettings();
    //******************************
    void addQuickLaunch();
    void addButton(QuickLaunchAction* action);

    void buttonDeleted(int);
    void customContextMenu(QPoint);
    void addLancher();
    void addButton(QString txt);
    void switchButtons(int first, int second);
    void saveSettings();

    void dragEnterEvent(QDragEnterEvent *e);
    void dropEvent(QDropEvent *e);

    //********************task

    void handlePropertyNotify(XPropertyEvent* event);
    void refreshTaskList();
    void addAppTaskToLancher();
    void activeWindowChanged();
    DActionTaskbar* buttonByWindow(Window window) const;
    bool windowOnActiveDesktop(Window window) const;

    void getActinveWindowProperty();
void getwmBoreder();


};

#endif // DOCKBARWIDGET_H
