/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#ifndef DACTIONTASKBAR_H
#define DACTIONTASKBAR_H
#include <QtGui>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <QToolButton>
class DActionTaskbar : public QToolButton
{
          Q_OBJECT
public:

          explicit DActionTaskbar(QSize size,const Window window, QWidget *parent = 0);
QString appName();
QString classeName();

signals:

protected:
          // virtual void dragEnterEvent(QDragEnterEvent *event);
          //virtual void dragLeaveEvent(QDragLeaveEvent *event);
          void mousePressEvent(QMouseEvent *event);

protected:
          void contextMenuEvent( QContextMenuEvent* event);
private:
          Window  m_Window;
        QAction *m_actParent;
          QList<QAction *>m_listQctions;
private slots:
          void getIcon();                //ايقونة البرنامج
          void getText();                //نص لابرنامج

          /**********عمليات النوافذ***************/
          void minimizeWindow();                  //تصغير النافذة
          void restoreWindow();                   //استعادة النافذة من التصغير
          void moveWindowToDesktop();             //نقل النافذة الى سطح المكت//
          void unMaximizeWindow();  //استعادة النافذة من التكبير
          void shadeWindow();          //تحجيم النافذة اي نظليلها
          void unShadeWindow();         //استعادة النافذة من التحجيم
          void closeApplication();           //غلق النافذة
          void maximizeWindow();        //تكبير التافذة
          void setApplicationLayer();             //وضع النافذة فوق تحت عادي
public slots:
        void setParentActions(QList<QAction *>list);
        void setParentAction(QAction *act);
};

#endif // DACTIONTASKBAR_H
