/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#include "dialogaddaction.h"
#include "ui_dialogaddaction.h"
#include <QDebug>
#include <QFile>
#include <QDir>
#include <QFileDialog>
#include "../libraries/mimetypexdg.h"
DialogAddAction::DialogAddAction(QuickLaunchAction *act,QWidget *parent) :
          QDialog(parent),
          ui(new Ui::DialogAddAction)
{
          ui->setupUi(this);
          QString locale = QLocale::system().name().section("_",0,0);

          if(locale=="ar")
              setLayoutDirection(Qt::RightToLeft);

          this->setWindowIcon(QIcon::fromTheme("configure",QIcon::fromTheme("document-properties")));
          this->setAttribute(Qt::WA_DeleteOnClose,true);
          ui->buttonBox->addButton(QDialogButtonBox::Ok);
          ui->lineEditName->setText(act->text());
          ui->lineEditExec->setText(act->data().toString().section("|",0,0));
          ui->pushButton->setIcon(act->icon());

m_type=act->settingsMap()["name"].section("|",1,1);

        m_iconName=act->settingsMap()["icon"];
          ui->treeWidget->setVisible(false);
          //ui->lineEditSearsh->setVisible(false);
          ui->lineEditIcon->setText(m_iconName);
          this->resize(430,150);
}
DialogAddAction:: DialogAddAction(QWidget *parent) :
          QDialog(parent),
          ui(new Ui::DialogAddAction)
{
          ui->setupUi(this);
          QString locale =this->locale().name().section("_",0,0);

          if(locale=="ar")
              setLayoutDirection(Qt::RightToLeft);
          this->setAttribute(Qt::WA_DeleteOnClose,true);
          qDebug()<<"this 1";
          ui->treeWidget->setVisible(true);
  //        ui->lineEditSearsh->setVisible(true);
          QIcon icn=QIcon::fromTheme("list-add");
          QPushButton *btnAdd=new QPushButton(icn,trUtf8("Add"),this);
          ui->buttonBox->addButton(btnAdd,QDialogButtonBox::ApplyRole);
          connect(btnAdd,SIGNAL(clicked()) ,this,SLOT(applyAdd()));
          chargeTreeWidget();
          this->resize(430,300);
}

DialogAddAction::~DialogAddAction()
{
          qDebug()<<"delet 1";
          delete ui;
}


void DialogAddAction::chargeTreeWidget()
{
          QStringList list;
          list<<trUtf8("Islamic")<<trUtf8("Office")<<trUtf8("AudioVideo")<<trUtf8("Graphics")
             <<trUtf8("Game")<<trUtf8("Development")<<trUtf8("Utility")
            <<trUtf8("Network")<<trUtf8("Settings")<<trUtf8("System")
           <<trUtf8("Other");
          enum  { NumIndex = 11};
          QTreeWidgetItem *item[NumIndex];
          for(int i=0 ;i<list.count();i++){
                    qDebug()<<"treewidjet :"<<i;
                    item[i]=new  QTreeWidgetItem(ui->treeWidget);
                    item[i]->setText(0,list.at(i));
          }

          QFile file(QDir::homePath()+"/.config/elokab/applictions");

          if (!file.open(QFile::ReadOnly)){
                    qDebug()<<QDir::homePath()+"/.config/elokab/applictions \n  "+file.errorString();
                    return ;
          }
          QTextStream textStream(&file);
          QString line;

          line= textStream.readLine();//premier line

          while (!line.isNull()) {
              //   QString data=openDesktopEntry(fileName);
              // qDebug()<<data;
              QString name=line.section("|",0,0);
              QString exec=line.section("|",1,1);
              QString category=line.section("|",2,2);
              QString icon=line.section("|",3,3);
              QTreeWidgetItem *item=new QTreeWidgetItem;
              item->setData(1,1,exec);
               item->setData(2,2,icon);
              //   item->setIcon(0,QIcon::fromTheme(icon.trimmed(),QIcon::fromTheme("application-x-executable")));
              item->setText(0,name);

              if(QFile::exists(icon)){
                  item->setIcon(0,QIcon(icon));
              }else{
                  QIcon icnF=MimeTypeXdg::getIconFromeTheme(icon);
                 // item->setIcon(0,QIcon::fromTheme(icon,QIcon::fromTheme("application-x-executable",QIcon(":/icons/applications-system.png"))));
                  item->setIcon(0,icnF);
              }
              if(category.contains("Islamic")){ ui->treeWidget->topLevelItem(0)->addChild(item); }

              else  if(category.contains("Office")) {ui->treeWidget->topLevelItem(1)->addChild(item);}

              else  if(category.contains("AudioVideo")) {ui->treeWidget->topLevelItem(2)->addChild(item);}

              else  if(category.contains("Graphics"))   {ui->treeWidget->topLevelItem(3)->addChild(item);}

              else if(category.contains("Game"))        {ui->treeWidget->topLevelItem(4)->addChild(item);}

              else if(category.contains("Development")) {ui->treeWidget->topLevelItem(5)->addChild(item);}

              else if(category.contains("Utility"))     {ui->treeWidget->topLevelItem(6)->addChild(item);}

              else  if(category.contains("Network"))    {ui->treeWidget->topLevelItem(7)->addChild(item);}

              else if(category.contains("Settings"))    {ui->treeWidget->topLevelItem(8)->addChild(item);}

              else if(category.contains("System"))      {ui->treeWidget->topLevelItem(9)->addChild(item);}

              else {   ui->treeWidget->topLevelItem(10)->addChild(item);}


              line= textStream.readLine();
          }
          file.close();


}




void DialogAddAction::on_treeWidget_itemSelectionChanged()
{
          QTreeWidgetItem *item=ui->treeWidget->currentItem();
          if(item){
                    if(item->parent()){
                              ui->lineEditName->setText(item->text(0));
                              ui->lineEditExec->setText(item->data(1,1).toString());
                              QPixmap pix=item->icon(0).pixmap(48,48);
                             ui->pushButton->setIcon(QIcon(pix));
                              m_iconName=item->data(2,2).toString();
                            //  ui->lineEditIcon->setText(m_iconName);
                    }
          }
        //  qDebug()<<ui->lineEditExec->text();
}

void DialogAddAction::on_buttonBox_clicked(QAbstractButton *button)
{

          if(ui->buttonBox->standardButton(button)==QDialogButtonBox::Ok){
                    if(ui->lineEditExec->text().isEmpty()||ui->lineEditName->text().isEmpty())
                              return;
                    QString name=ui->lineEditName->text();
                    QString exec=ui->lineEditExec->text();

                    emit accepteChange(name+"#"+m_type+"|"+exec+"|"+m_iconName);
                    this->accept();
          }
}
void DialogAddAction::applyAdd()
{

          if(ui->lineEditExec->text().isEmpty()||ui->lineEditName->text().isEmpty())
                    return;
          QString name=ui->lineEditName->text();
          QString exec=ui->lineEditExec->text();

          emit accepteAdd(name+"|"+exec+"|"+m_iconName);
}

void DialogAddAction::on_pushButton_clicked()
{
          QFileDialog dlg;
//".png", ".svg", ".svgz", ".svg.gz", ".xpm"
          QString fn = dlg.getOpenFileName(this, tr("Open Images Files..."),
                                           QDir::homePath(), trUtf8("Image File (*.png *.svg *.svgz *.svg.gz *.xpm);;All Files (*)"));
          if (!fn.isEmpty())
          {
                    ui->pushButton->setIcon(QIcon(fn));
                    ui->lineEditIcon->setText(fn);
                    m_iconName=fn;

          }
}

void DialogAddAction::on_toolButton_clicked()
{
          QFileDialog dlg;

          QString fn = dlg.getOpenFileName(this, tr("Open Files..."),
                                           QDir::homePath(), trUtf8("All Files (*)"));
          if (!fn.isEmpty())
          {
                    ui->lineEditExec->setText(fn);

          }
}

void DialogAddAction::on_lineEditIcon_textChanged(const QString &arg1)
{
qDebug()<<arg1;
      QIcon icon;
      icon=QIcon::fromTheme(arg1);
      if(QFile::exists(arg1)){
          icon=QIcon(arg1);
           ui->pushButton->setIcon(icon);
             m_iconName=arg1;
      }else if(!icon.isNull()){

           ui->pushButton->setIcon(icon);
             m_iconName=arg1;
      }

}
