/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#ifndef DIALOGADDACTION_H
#define DIALOGADDACTION_H
#include "quicklaunchaction.h"

#include "dialogaddaction.h"
#include <QDialog>
#include <QTreeWidgetItem>
#include <QAbstractButton>
namespace Ui {
class DialogAddAction;
}

class DialogAddAction : public QDialog
{
          Q_OBJECT

public:
          DialogAddAction(QuickLaunchAction * act ,QWidget *parent = 0);
          DialogAddAction(QWidget *parent = 0);
          ~DialogAddAction();
signals:
          void accepteAdd(QString text);
          void accepteChange(QString text);
private:
          Ui::DialogAddAction *ui;
          QString m_type;
          QString m_iconName;
private slots:
          void chargeTreeWidget();
          void on_treeWidget_itemSelectionChanged();
          void on_buttonBox_clicked(QAbstractButton *button);
          void applyAdd();
          void on_pushButton_clicked();
          void on_toolButton_clicked();
          void on_lineEditIcon_textChanged(const QString &arg1);
};

#endif // DIALOGADDACTION_H
