/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#include "quicklaunchlayout.h"
#include "quicklaunchbutton.h"
#include <QFrame>
#include <QDebug>
QuickLaunchLayout::QuickLaunchLayout(QWidget * parent)
          : QHBoxLayout(parent)

{
          setSpacing(1);
          setContentsMargins(1, 1, 1,1);
setSizeConstraint(QLayout::SetMaximumSize);
}

void QuickLaunchLayout::addWidget(QuickLaunchButton *b)
{
          m_buttons << b;
          relayout();
}
 void QuickLaunchLayout::addWidget(DActionTaskbar *b)
 {
           m_buttonsTaskbar << b;
           relayout();
          // QHBoxLayout::insertWidget(index,b)
 }


void QuickLaunchLayout::removeWidget(QuickLaunchButton *b)
{
          m_buttons.removeAll(b);

          relayout();
}
void QuickLaunchLayout::removeWidget(DActionTaskbar *b)
{
          m_buttonsTaskbar.removeAll(b);

          relayout();
}


QuickLaunchButton* QuickLaunchLayout::buttonAt(int index)
{
          if ((index >= 0) && (index < m_buttons.size()))
                    return m_buttons[index];
          return NULL;
}
DActionTaskbar* QuickLaunchLayout::buttonTaskAt(int index)
{
          if ((index >= 0) && (index < m_buttonsTaskbar.size()))
                    return m_buttonsTaskbar[index];
          return NULL;
}

//**********************    void addWidget(DActionTaskbar *b);

void QuickLaunchLayout::swapButtons(QuickLaunchButton * b1, QuickLaunchButton *b2)
{
          int tmp1 = indexOf(b1);
          int tmp2 = indexOf(b2);

          if (tmp1 != tmp2)
          {
                    m_buttons.swap(tmp1, tmp2);
                    relayout();
          }
}


void QuickLaunchLayout::relayout()
{


          QLayoutItem *child;
          while ((child = takeAt(0)) != 0)
          {
                  //  qDebug()<<"geometry---------------"<<child->geometry();
                    delete child;
          }

          foreach (QLabel *b, m_label)
          {

                    m_label.removeAll(b);
                    delete b;
          }

          foreach (QuickLaunchButton *b, m_buttons)
          {
                       QHBoxLayout::addWidget(b);//QuickLaunchButton
//                    QVBoxLayout *vb=new QVBoxLayout;

//                    QSpacerItem  *verticalSpacer = new QSpacerItem(1, 1, QSizePolicy::Minimum, QSizePolicy::Expanding);

//                    vb->addItem(verticalSpacer);
//                    vb->addWidget(b);
//                    vb->addSpacing(5);

//                    QHBoxLayout::addLayout(vb);
          }

          foreach (DActionTaskbar *b, m_buttonsTaskbar)
          {
                         QHBoxLayout::addWidget(b);
                         b->setMinimumWidth(m_sizeH+8);
                        b->setMinimumHeight(m_sizeH+8);
//                    QVBoxLayout *vb=new QVBoxLayout;
//                    QLabel *lab=new QLabel;
//                    m_label<<lab;
//                    lab->setMaximumHeight(5);
//                    lab->setMaximumWidth(16);
//                    lab->setStyleSheet("background-color: qradialgradient(spread:pad, cx:0.5, cy:0.5, radius:0.5, fx:0.5, fy:0.5, stop:0.219388 rgba(189, 199, 217, 187), stop:0.617347 rgba(228, 248, 255, 147), stop:0.836735 rgba(255, 255, 255, 75), stop:0.994898 rgba(255, 255, 255, 0));");
//                   // lab->setPixmap(QPixmap("/home/yahia/indicator.png"));
//                    lab->setScaledContents(true);
//                    QHBoxLayout   * bLayou=new QHBoxLayout;
//                    bLayou->addWidget(lab);

//                    QSpacerItem  *verticalSpacer = new QSpacerItem(1, 1, QSizePolicy::Minimum, QSizePolicy::Expanding);
//                    vb->addItem(verticalSpacer);
//             b->setMinimumWidth(m_sizeH+8);
//              b->setMinimumHeight(m_sizeH+8);
//              vb->addWidget(b);
//                   vb->addLayout(bLayou);
////vb->addSpacing(5);
//                    QHBoxLayout::addLayout(vb);

          }

}

