/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#ifndef QUICKLAUNCHLAYOUT_H
#define QUICKLAUNCHLAYOUT_H
#include <QHBoxLayout>
#include <QGridLayout>

#include "dactiontaskbar.h"
class QuickLaunchButton;
class DActionTaskbar;
class QuickLaunchLayout : public QHBoxLayout
{
          Q_OBJECT
public:
          explicit  QuickLaunchLayout(QWidget *parent = 0);

          void addWidget(QuickLaunchButton *b);
          void addWidget(DActionTaskbar *b);

          void removeWidget(QuickLaunchButton *b);
          void removeWidget(DActionTaskbar *b);
void swapButtons(QuickLaunchButton * b1, QuickLaunchButton *b2);
          QuickLaunchButton* buttonAt(int index);
       DActionTaskbar* buttonTaskAt(int index);

        QList<QuickLaunchButton*> buttons() { return m_buttons; }
//         QList<DActionTaskbar*> buttonsTaskbar() { return m_buttonsTaskbar; }

        void setSizeH(int size)
        {
             m_sizeH=     size;
        }


private:
          //RazorPanel *m_panel;
          QList<QuickLaunchButton*> m_buttons;
          QList<DActionTaskbar*> m_buttonsTaskbar;
           QList<QLabel*> m_label;
           int m_sizeH;
private slots:
          void relayout();
public slots:

};

#endif // QUICKLAUNCHLAYOUT_H
