/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#include <QtGui/QApplication>
#include "dockbarwidget.h"
#include "ddockapplication.h"

int main(int argc, char *argv[])
{
         DdockApplication a(argc, argv);
          a.setApplicationName("elokab-dock");
          a.setApplicationVersion("0.1");
          a.setOrganizationName("elokab");
          a.setWindowIcon(QIcon(":/icons/elokab-dock.png"));
          QDir appDir(a.applicationDirPath());
          QString appPath;

          appDir.cdUp();
          appPath=  appDir.absolutePath()+"/share/elokab/elokab-dock";

          QSettings globalSetting("elokab","elokabsettings");
          globalSetting.beginGroup("Language");
            QString locale=globalSetting.value("Name","Default").toString();
          globalSetting.endGroup();

          if(locale=="Default")
          locale = QLocale::system().name().section("_",0,0);

      QLocale::setDefault(QLocale(locale));
          QString translatorFileName = QLatin1String("qt_");
          translatorFileName += locale;
          QTranslator *translatorsys = new QTranslator;
          if (translatorsys->load(translatorFileName, QLibraryInfo::location(QLibraryInfo::TranslationsPath)))
              QApplication::installTranslator(translatorsys);

          QTranslator translator;

 translator.load(QString(appPath+"/languages/elokab-dock_"+locale+".qm"));
          a.installTranslator(&translator);

QApplication::setLayoutDirection(Qt::LeftToRight);



          DockBarWidget w;
a.setDock(&w);
          w.show();
          return a.exec();
}
