/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#ifndef PLUGINSINTERFACE_H
#define PLUGINSINTERFACE_H

#include <QObject>
#include <QtGui>
//! [0]
class PluginsInterface
{
public:

    virtual ~PluginsInterface() {}

    virtual  void setLayout(QHBoxLayout */*p*/)= 0;                   /*لتضمين الودجات داخل محتوى اللوحة*/
    virtual  void x11EventFilter(XEvent* /*event*/)= 0;                /*لتلقي الاشارات من مكتبات  x11  */
    virtual  void setSize(QSize /*size*/)= 0;                                   /*لمعرفة حجم اللوحة*/
    virtual  void setActions(QList<QAction *>/*list*/)= 0;            /*لتلقي ازرار بعض اوامر اللوحة مثل الاغدادات او قوائم*/
  virtual  void  setKeySequence(QKeySequence)=0;
  virtual  QString  keySequence()=0;
   virtual  void themeChanged()=0;
};
//! [0]


QT_BEGIN_NAMESPACE

Q_DECLARE_INTERFACE(PluginsInterface,
                    "com.dpanel.Plugin.PluginsInterface/1.0")


QT_END_NAMESPACE
#endif // PLUGINSINTERFACE_H
