/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef ELOKABSETTINGS_H
#define ELOKABSETTINGS_H

#include <QSettings>
#include <QFileSystemWatcher>
class elokabSettings : public QSettings
{
    Q_OBJECT

public:
    explicit elokabSettings(const QString & organization, const QString & application = QString(), QObject *parent = 0);
    explicit elokabSettings( QObject *parent = 0);

signals:
    /// Signal emitted when the icon theme has changed.
    void iconThemeChanged();
    /// Signal emitted when the widget theme has changed.
    void widgetStyleChanged();
    /// Signal emitted when the themes has changed.
    void ThemesChanged();
   /// Signal emitted when the shortcuts has changed.
     void shortcutsKeysChanged();
public slots:
QString loadIconThems();
QString loadStyleWidget();
private:
    QFileSystemWatcher *m_fileWatcher;
    QString m_iconTheme;
    QString m_styleWidget;
    QString m_Themes;
private slots:
    void fileChanged();
    void shortcutsCanged();
    QString loadtheme();
};

#endif // ELOKABSETTINGS_H
