/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#include "widgeticonsthemes.h"
#include "ui_widgeticonsthemes.h"
#include <QSettings>
#include <QDir>
#include <QDebug>
widgetIconsThemes::widgetIconsThemes(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::widgetIconsThemes)
{
    ui->setupUi(this);
    QStringList listThemePath=QIcon::themeSearchPaths();
  //  listThemePath.append(QIcon::themeSearchPaths());
        listThemePath.append(QDir::homePath()+"/.icons");
        listThemePath.append(QDir::homePath()+"/.kde/share/icons");
       listThemePath.append(QDir::homePath()+"/.kde4/share/icons");
        listThemePath.append("/usr/share/icons");
       listThemePath.removeDuplicates();

       QIcon::setThemeSearchPaths(listThemePath);

    QStringList pathList;
    int count=QIcon::themeSearchPaths().count();
    //QIcon::setThemeSearchPaths(listThemePath);
    for (int i=0;i<count;i++){
        QString dirPath= QIcon::themeSearchPaths().at(i);
        QDir dirS(dirPath);
        foreach(QString dir,dirS.entryList(QDir::AllDirs| QDir::NoSymLinks| QDir::NoDotAndDotDot )) {
            pathList<<      getDirIconTeme(dirPath+"/"+dir);
        }

    }
    pathList.removeDuplicates();
    pathList.removeAll("");
    ui->comboBoxIcons->addItems(pathList);

    QSettings globalSetting("elokab","elokabsettings");

    globalSetting.beginGroup("Themes");
    m_iconThemes=globalSetting.value("iconsTheme",QIcon::themeName()).toString();
    globalSetting.endGroup();
    int indx=ui->comboBoxIcons->findText(m_iconThemes);
    ui->comboBoxIcons->setCurrentIndex(indx);

    on_comboBoxIcons_activated(indx);

}

widgetIconsThemes::~widgetIconsThemes()
{
    delete ui;
}
QString widgetIconsThemes::getDirIconTeme(QString dir)
{
          QDir dirPath(dir);
          if(!QFile::exists(dir+"/index.theme"))return "";


          QSettings settings(dir+"/index.theme",QSettings::IniFormat);
          //settings.setIniCodec(QTextCodec::codecForName("UTF-8"));
          settings.beginGroup("Icon Theme");
          if(!settings.contains("Directories"))return "" ;
         // QString name=settings.value("Name","").toString();
          //   QString directories=settings.value("Example","").toString();
          // qDebug()<<dir+"/index.theme  :"<<name<<" : "<<directories;
          settings.endGroup();
return dirPath.dirName();
          //   if (directories.isEmpty())return ;
       //   ui->comboBoxIcons->addItem(dirPath.dirName(),name);
          //qDebug()<<dirPath.dirName();
}
void widgetIconsThemes::on_comboBoxIcons_activated(int index)
{
    QIcon::setThemeName(ui->comboBoxIcons->currentText());

    ui->toolButtonFile->setIcon(QIcon::fromTheme("unknown").pixmap(48,48));
    ui->toolButtonFolder->setIcon(QIcon::fromTheme("folder").pixmap(48,48));
    ui->toolButtonExec->setIcon(QIcon::fromTheme("application-x-executable",QIcon(":/icons/applications-system.png")).pixmap(48,48));
emit themeChanged();

}
void widgetIconsThemes::saveIconThemes()
{

        if(m_iconThemes!=ui->comboBoxIcons->currentText()){

                qDebug()<<"iconThemes has changed";
                m_iconThemes=ui->comboBoxIcons->currentText();

                QString iconsTheme=ui->comboBoxIcons->currentText();
                QSettings globalSetting("elokab","elokabsettings");

                globalSetting.beginGroup("Themes");

                globalSetting.setValue("iconsTheme",iconsTheme);

                globalSetting.endGroup();
        }
}

