#include "menugenirator.h"
#include <QObject>
#include <QDir>
#include <QDebug>
#include <QSettings>

#include <QTextCodec>


MenuGenirator::MenuGenirator(const QString &locale, QObject *parent) :
        QObject(parent), m_locale(locale)
{
        m_sWatcher=new QFileSystemWatcher;
        connect(m_sWatcher, SIGNAL(directoryChanged(QString)), this, SLOT(genirateAppFile()));
            loadSettings();
            saveSettings();
}

bool MenuGenirator::appFilesExist()
{

          QFile fileApp( QDir::homePath()+"/.config/elokab/applictions");

          QString dirUsers="/usr/share/applications";
          QString dirLocal=  QDir::homePath()+"/.local/share/applications";

          int count1=countDesktopDir(dirLocal);             /*ex:  /home/usrer/.local/share/applications  */
          int count2=countDesktopDir(dirUsers);             /*     "/usr/share/applications"                         */
          int count=count1+count2;                                    /*    عدد التطبيقات في المسارين                                  */

          if (count!=m_appCount||!fileApp.exists()){         /*  اذا كان العدد مختلف او القائمة غير موجودة                  */
                    genirateAppFile();
                    m_appCount=count;
                    saveSettings();

                    return true;
          }
          return false;
}

//! [0-1] ------------------------------------------------حمل عدد التطبيقات  ---------------------------------------------- */
void MenuGenirator::loadSettings()
{
    QSettings setting("elokab","elokabsettings");
          setting.beginGroup("MenuAppCount");
          m_appCount=setting.value("Num",0).toInt();
          setting.endGroup();
}
//! [0-2] ------------------------------------------------حفظ عدد التطبيقات  ---------------------------------------------- */
void MenuGenirator::saveSettings()
{
          QSettings setting("elokab","elokabsettings");
          setting.beginGroup("MenuAppCount");
          setting.setValue("Num",m_appCount);
          setting.endGroup();
       //     emit appDesktopChanged();
}
//! [1-1] ------------------------------------------------عد المجلدات  ---------------------------------------------- */
int MenuGenirator::countDesktopDir(QString dir)
{
          int count=0;
          count=count+ countDesktopFile(dir);

          QString subdir;
          QDir dirS(dir);
          foreach ( subdir, dirS.entryList(QDir::AllDirs| QDir::NoSymLinks| QDir::NoDotAndDotDot )){
                    count=count+ countDesktopFile(dir+"/"+subdir);

          }
          return count;
}
//! [1-1] ------------------------------------------------عد الملفات  ---------------------------------------------- */
int MenuGenirator::countDesktopFile(QString   dir)
{
          int count=0;
          QString subfile;
          QDir dirS(dir);
          foreach ( subfile, dirS.entryList(QDir::AllEntries|  QDir::NoDotAndDotDot )){
                    QFileInfo fi(dir+"/"+subfile);
                    if(!fi.isDir()&&fi.completeSuffix()=="desktop"){
                              count++;
                    }
          }
          return count;
}
//! [2] ------------------------------------------------انشاء ملف بالتطبيقات الموجودة  ------------------------------------- */
void MenuGenirator::genirateAppFile()
{


          QFile fileApp( QDir::homePath()+"/.config/elokab/applictions");

          if (!fileApp.open(QFile::WriteOnly)){
                    return ;
          }
          QTextStream out(&fileApp);
          out.setCodec(QTextCodec::codecForName("UTF-8"));
          QString dirUsers="/usr/share/applications";
          QString dirLocal=  QDir::homePath()+"/.local/share/applications";
          chargeDesktopDir( dirUsers);
          chargeDesktopDir( dirLocal);
          for (int i=0;i<wordList.count();i++){
                    QString data=wordList.at(i);
                    out << data+"\n";
          }
          wordList.clear();
          fileApp.close();

}
//! [2-1] ------------------------------------------------تحميل المجادات المحددة  ------------------------------------- */
void MenuGenirator::chargeDesktopDir(QString dir)
{

          chargeDesktopFile(dir);


          QString subdir;
          QDir dirS(dir);
          foreach ( subdir, dirS.entryList(QDir::AllDirs| QDir::NoSymLinks| QDir::NoDotAndDotDot )){
                    chargeDesktopFile(dir+"/"+subdir);

          }
          //return true;
}
//! [2-2] ------------------------------------------------تحميل الملفات المحددة  ------------------------------------- */
void MenuGenirator::chargeDesktopFile(QString   dir)
{
          QString subfile;
          QDir dirS(dir);
          if (!m_sWatcher->directories().contains(dir))
              m_sWatcher->addPath(dir);
            qDebug()<<"mWatcher:--------: "<<dir;
          foreach ( subfile, dirS.entryList(QDir::AllEntries|  QDir::NoDotAndDotDot )){
                    QFileInfo fi(dir+"/"+subfile);
                    if(!fi.isDir()&&fi.completeSuffix()=="desktop"){
                              QString data=openDesktopEntry(dir+"/"+subfile);
                              if(!data.isEmpty())
                                        wordList.append(data);
                    }
          }
}
//! [2-3] ---------------------------------------فتح الملفات لاستحراج المعلومات  ------------------------------------- */
QString MenuGenirator::openDesktopEntry(QString file)
{

          QFileInfo fi(file);
          QString baseName=fi.baseName();
          QSettings settings(file,QSettings::IniFormat);
          settings.setIniCodec(QTextCodec::codecForName("UTF-8"));
          settings.beginGroup("Desktop Entry");
          QString nameold=settings.value("Name",baseName).toString();
          QString name=settings.value("Name["+m_locale+"]",nameold).toString();
          QString exec=settings.value("Exec",baseName).toString();
          QString TryExec=settings.value("TryExec",exec).toString();
          QString icon=settings.value("Icon",baseName).toString();
          bool NoDisplay=settings.value("NoDisplay",false).toBool();

          settings.endGroup();
          if(NoDisplay==true)return "";
          QString category="Other";
          QFile files(file);
          if(files.open( QFile::ReadOnly)){
                    QTextStream textStream(&files);
                    QString line = textStream.readLine();//premier line;

                    while   (!line.isNull()) {
                              line = textStream.readLine();
                              if(line.contains("Categories=")){
                                        category=line.remove("Categories=");
                                        break;
                              }
                    }
          }
          files.close();

            qDebug()<<"categy : "<<category;
            qDebug()<<"AppMenu : "<<name;
          TryExec.remove("-caption");
          return name+"|"+TryExec.section("%",0,0)+"|"+category+"|"+icon+"|"+file;

}
