/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */
#ifndef MIMETYPEXDG_H
#define MIMETYPEXDG_H

#include <QObject>
#include <QString>
#include <QIcon>
#include <QDir>
class MimeTypeXdg
{

public:
          static QString getMimeTypeByFile(QString fileName);//get a mime type by file name example "application-x-shellscript"
          static QString getMimeType(QString fileName);//get a mime type by file name example "application-x-shellscript"
          static QString getAppByMimeType(QString fileName);//get a mime type by file name example "application-x-shellscript"
    static QStringList getAppSByMimeType(QString fileName);
          static QString getMimeTypeBySufix(QString sufix);//get a mime type by sufix example "application-x-shellscript"
          static QString getIconFillBack(QString mimeType);//get a fillback icon ex "image" "video" "unknow"
          static QString getInfoFromUnknowSufix(QString fileName);//value example "#!/bin/sh" or "unknow"
          static QString getInfoFromDesktopFile(QString fileName,QString lC ); //get a name and exec and icon from .desktop
          static QString getInfoFromDesktopApp(QString fileName ); //get info from a list file app if exist
         static  QString getinfoAppFromDesktopApp(QString appName ,QString className);
          static QString getIconFromDesktopApp(QString fileName );
           static QIcon getIconFromCharPixmap(QDir dir, QString iconName );
          static  QIcon getIconFromeTheme(QString  iconName);
           static    QIcon getIconsFromeTheme(QString  iconName,QString fillback);
signals:

public slots:
protected:
          explicit  MimeTypeXdg();

private:


private slots:
          static   QString iconName(QString result) ;
        static     QIcon chargeIconFile(QString dir,QString iconName);
};

#endif // MIMETYPEXDG_H
